"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.createConfiguredNodePlugin = exports.createNodePlugin = void 0;
const publisher_1 = require("./publisher");
const package_json_1 = require("../../../package.json");
function normalizeEvent(ctx) {
    ctx.updateEvent('context.library.name', 'AnalyticsNode');
    ctx.updateEvent('context.library.version', package_json_1.version);
    ctx.updateEvent('_metadata.nodeVersion', process.versions.node);
}
function createNodePlugin(publisher) {
    function action(ctx) {
        normalizeEvent(ctx);
        return publisher.enqueue(ctx);
    }
    return {
        name: 'Segment.io',
        type: 'after',
        version: '1.0.0',
        isLoaded: () => true,
        load: () => Promise.resolve(),
        alias: action,
        group: action,
        identify: action,
        page: action,
        screen: action,
        track: action,
    };
}
exports.createNodePlugin = createNodePlugin;
const createConfiguredNodePlugin = (props) => {
    const publisher = new publisher_1.Publisher(props);
    return {
        publisher: publisher,
        plugin: createNodePlugin(publisher),
    };
};
exports.createConfiguredNodePlugin = createConfiguredNodePlugin;
//# sourceMappingURL=index.js.map